<?php
$hasConfig=true;
$pageTitle="Home: ".session::getUser()['fullname'];
if(isset($isDefaultHomepage)) {
	//An admin is setting up the default homepage for new users
	$pageTitle="Configure default homepage for new users";
}
include realpath(__DIR__).'/../_common/header.php'; ?>

<script type="text/javascript">
<?php if(isset($isDefaultHomepage)) {
	//An admin is setting up the default homepage for new users
	echo 'var isDefaultHomepage=true;';
	echo 'var apiUrl="/api/homepagedefaultbrick"';
} else {
	//This is the user's own homepage
	echo 'var isDefaultHomepage=false;';
	echo 'var apiUrl="/api/homepageuserbrick"';
} ?>

var grid=ui.grid(true);

var Homepage={ 
	toggleConfig:function(){
		if($("configbutton").isActive){
			Homepage.stopConfig();
		} else {
			Homepage.startConfig();
		}
	},
	startConfig:function(){
		document.body.style.overflow="hidden";
		$("configbutton").isActive=true;
		$$(".box").each(function(box){
//			box.down("h2").insert({'top':'<img src="/images/icons/'+skin.boxheadericontheme+'/close.gif" class="closeicon" />'});
			box.down("h2").insert({'top':'<span class="closeicon" >&nbsp;</span>'});
			box.down("h2").addClassName("handle");
		});
		DragDrop.setup($$(".box"),$$(".boxslot"),Homepage.onDrop);
		$$(".closeicon").each(function(ci){
			ci.observe("click",Homepage.removeBrick);
		});
		$$(".boxslot").each(function(s){
			s.observe("mouseover",function(){ s.addClassName("activedroppable"); });
			s.observe("mouseout",function(){ s.removeClassName("activedroppable"); });
			s.observe("click",function(){ Homepage.startAdd(s) });
		});
	},
	stopConfig:function(){
		$("configbutton").isActive=false;
		$$(".closeicon").each(function(ci){
			ci.remove();
		});
	},

	onDrop:function(box, slot){
		var boxWidth=1;
		var boxHeight=1;
		var slotRow=1;
		var slotCol=1;
		if(box.hasClassName("w2")){ boxWidth=2; }
		if(box.hasClassName("w3")){ boxWidth=3; }
		if(box.hasClassName("h2")){ boxHeight=2; }
		if(box.hasClassName("h3")){ boxHeight=3; }
		if(slot.hasClassName("r2")){ slotRow=2; }
		if(slot.hasClassName("r3")){ slotRow=3; }
		if(slot.hasClassName("c2")){ slotCol=2; }
		if(slot.hasClassName("c3")){ slotCol=3; }
		var bottomEdge=slotRow+boxHeight-1;
		var rightEdge=slotCol+boxWidth-1;
		if(bottomEdge>3 || rightEdge>3){
			DragDrop.abortDrop();
			return false;
		}
		
		//Don't allow bricks to overlap
		var occupied=[];
		occupied.push([-1,-1,-1,-1]);
		occupied.push([-1,0,0,0]);
		occupied.push([-1,0,0,0]);
		occupied.push([-1,0,0,0]);
		$$(".box").each(function(b){
			if(b.id==box.id){ return; } //and continue through the "each"
			var h=1*b.dataset.h;
			var w=1*b.dataset.w;
			var r=1*b.dataset.r;
			var c=1*b.dataset.c;
			for(row=r;row<r+h;row++){
				for(col=c;col<c+w;col++){
					occupied[row][col]=1;
				}
			}
		});
		for(r=slotRow;r<slotRow+boxHeight;r++){
			for(c=slotCol;c<slotCol+boxWidth;c++){
				if(1==occupied[r][c]){
					DragDrop.abortDrop();
					return false;
				}
			}
		}
		
		box.removeClassName("r1").removeClassName("r2").removeClassName("r3");
		box.removeClassName("c1").removeClassName("c2").removeClassName("c3");
		if(slot.hasClassName("r1")){ box.addClassName("r1"); box.dataset.r=1; }
		if(slot.hasClassName("c1")){ box.addClassName("c1"); box.dataset.c=1; }
		if(slot.hasClassName("r2")){ box.addClassName("r2"); box.dataset.r=2; }
		if(slot.hasClassName("c2")){ box.addClassName("c2"); box.dataset.c=2; }
		if(slot.hasClassName("r3")){ box.addClassName("r3"); box.dataset.r=3; }
		if(slot.hasClassName("c3")){ box.addClassName("c3"); box.dataset.c=3; }
		box.style.left=slot.positionedOffset().left+"px";
		box.style.top=slot.positionedOffset().top+"px";
		var patchUrl='';
		if(null!=box.dataset.homepageuserbrickid){
			patchUrl='/api/homepageuserbrick/'+box.dataset.homepageuserbrickid;
		} else {
			patchUrl='/api/homepagedefaultbrick/'+box.dataset.homepagedefaultbrickid;
		}
		new Ajax.Request(patchUrl, {
			method:"patch",
			postBody:"csrfToken="+csrfToken+"&row="+slotRow+"&col="+slotCol,
			onSuccess:Homepage.drop_onSuccess,
			onFailure:Homepage.drop_onFailure
		});
	},
	drop_onSuccess:function(transport){
		AjaxUtils.checkResponse(transport);
	},
	drop_onFailure:function(transport){
		AjaxUtils.checkResponse(transport);
	},

	removeBrick:function(evt){
		var closeIcon=$(evt.target);
		var box=closeIcon.up(".box");
		var name=box.id;
		if(!confirm("Remove the brick?")){
			return false;
		}
		var deleteUrl='';
		if(null!=box.dataset.homepageuserbrickid){
			deleteUrl='/api/homepageuserbrick/'+box.dataset.homepageuserbrickid;
		} else {
			deleteUrl='/api/homepagedefaultbrick/'+box.dataset.homepagedefaultbrickid;
		}
		new Ajax.Request(deleteUrl, {
			method:"delete",
			postBody:"csrfToken="+csrfToken,
			onSuccess:function(transport){ Homepage.remove_onSuccess(transport,box) },
			onFailure:Homepage.remove_onFailure
		});
	},
	remove_onSuccess:function(transport,box){
		AjaxUtils.checkResponse(transport);
		box.remove();
	},
	remove_onFailure:function(transport){
		AjaxUtils.checkResponse(transport);
	},


	startAdd:function(slot){
		var row=slot.dataset.gridrow;
		var col=slot.dataset.gridcol;
		slot.removeClassName("activedroppable");
		var mbox=ui.modalBox({
			title:"Add brick to homepage",
			content:"Loading..."
		});
		new Ajax.Request("/api/homepagebrick",{
			method:'get',
			onSuccess:function(transport){ Homepage.startAdd_onSuccess(transport, slot); },
			onFailure:Homepage.startAdd_onFailure
		});
	},

	startAdd_onSuccess:function(transport, destinationSlot){
		if(!AjaxUtils.checkResponse(transport)){
			return false;
		}
		var addRow=1*destinationSlot.dataset.gridrow;
		var addCol=1*destinationSlot.dataset.gridcol;
		//calculate fit/non-fit sizes, then:
		var fittingBricks=new Array();
		var nonFittingBricks=new Array();
		var fittingSizes=new Array();
		var nonFittingSizes= new Array();
		fittingSizes.push("1x1"); //they clicked on this square, so it's open
		if(addRow>=3){ //double height won't fit on bottom
			nonFittingSizes.push("2x1");
			nonFittingSizes.push("2x2");
			nonFittingSizes.push("2x3");
		}
		if(addRow>=2){ //triple height won't fit in middle row
			nonFittingSizes.push("3x1");
			nonFittingSizes.push("3x2");
			nonFittingSizes.push("3x3");
		}
		if(addCol>=3){ //double width won't fit in right-hand column
			nonFittingSizes.push("1x2");
			nonFittingSizes.push("2x2");
			nonFittingSizes.push("3x2");
		}
		if(addRow>=2){ //triple width won't fit in middle column
			nonFittingSizes.push("1x3");
			nonFittingSizes.push("2x3");
			nonFittingSizes.push("3x3");
		}
		var occupied=[];
		occupied.push([-1,-1,-1,-1]);
		occupied.push([-1,0,0,0]);
		occupied.push([-1,0,0,0]);
		occupied.push([-1,0,0,0]);
		$$(".homepagebrick").each(function(b){
			var h=1*b.dataset.h;
			var w=1*b.dataset.w;
			var r=1*b.dataset.r;
			var c=1*b.dataset.c;
			for(row=r;row<r+h;row++){
				for(col=c;col<c+w;col++){
					occupied[row][col]=1;
				}
			}
		});
		transport.responseJSON.rows.each(function(brick){
			if($(brick.name)){
				//already in the layout
				return; //from internal function, continue
			}
			var h=brick.height*1;
			var w=brick.width*1;
			var brickSize=h+"x"+w;
			if(fittingSizes.indexOf(brickSize)>-1){
				fittingBricks.push(brick);
			} else if(nonFittingSizes.indexOf(brickSize)>-1){
				nonFittingBricks.push(brick);
			} else {
				//is brick going to overlap another if added at chosen spot? non-fitting. else fitting.
				var brickFits=true;
				for(r=addRow;r<=addRow+h-1;r++){
					for(c=addCol;c<=addCol+w-1;c++){
						if(1==occupied[r][c]){
							brickFits=false;
							break;
						}
					}
					if(!brickFits){ break; }
				}
				if(brickFits){
					fittingBricks.push(brick);
					fittingSizes.push(brickSize);
				} else {
					nonFittingBricks.push(brick);
					nonFittingSizes.push(brickSize);
				}
			}
		});
		if(0==fittingBricks.length && 0==nonFittingBricks.length){
			$("modalBox").down(".boxbody").innerHTML="No bricks are available to add to your homepage.";
			return;
		}
		$("modalBox").down(".boxbody").addClassName("hastable");
		var out='<table>';
		if(0==fittingBricks.length){
			out+='<tr><th colspan="2" style="text-align:center;">No bricks will fit in that slot. These are available but won\'t fit:</th></tr>';
		} else {
			out+='<tr><th colspan="2" style="text-align:center;">Available bricks:</th></tr>';
			fittingBricks.each(function(brick){
				var brickSize=brick.height+"x"+brick.width;
				var icon='<span title="'+brick.height+"x"+brick.width+' brick" class="bricksizeicon h'+brick.height+"w"+brick.width+'">&nbsp;</span>';
				out+='<tr class="bricklist" id="add_'+brick.name+'"><th>'+icon+'&nbsp;'+brick.title+'</th><td>'+brick.description+'</td></tr>';
			});
			if(0!=nonFittingBricks.length){
				out+='<tr><th colspan="2" style="text-align:center;">These bricks are available but won\'t fit in that slot:</th></tr>';
			}
		}
		nonFittingBricks.each(function(brick){
			var icon='<span title="'+brick.height+"x"+brick.width+' brick" class="bricksizeicon h'+brick.height+"w"+brick.width+'">&nbsp;</span>';
			out+='<tr class="bricklist" id="add_'+brick.name+'"><th>'+icon+'&nbsp;'+brick.title+'</th><td>'+brick.description+'</td></tr>';
		});
		out+='</table>';
		$("modalBox").down(".boxbody").innerHTML=out;
		fittingBricks.each(function(brick){
			$('add_'+brick.name).brick=brick;
			$('add_'+brick.name).style.cursor="pointer";
			$('add_'+brick.name).observe("click", function(){ Homepage.addHomepageBrick(this); } );
			$('add_'+brick.name).observe("mouseover", function(){ this.addClassName("activedroppable"); } );
			$('add_'+brick.name).observe("mouseout", function(){ this.removeClassName("activedroppable"); } );
		});
		$("modalBox").activeSlot=destinationSlot;
	},
	
	startAdd_onFailure:function(boxId,transport){
		var msg=transport.responseText;
		if(transport.responseJSON && transport.responseJSON.error){
			msg=transport.responseJSON.error;
		}
		alert("Could not add brick to homepage. The server said:\n\n"+msg+"\n\n\When you click OK, the page will reload.");
		ui.forceReload();
	},

	addHomepageBrick: function(tr){
		tr.innerHTML='<th style="text-align:center;" colspan="2">Adding brick to homepage...</th>';
		var brick=tr.brick;
		var addDestination=$("modalBox").activeSlot;
		var addRow=addDestination.dataset.gridrow;
		var addCol=addDestination.dataset.gridcol;
//		new Ajax.Request('/api/homepageuserbrick/',{
			new Ajax.Request(apiUrl,{
			method:'post',
			postBody:'homepagebrickid='+brick.id+'&row='+addRow+'&col='+addCol+'&csrfToken='+csrfToken,
			onSuccess:Homepage.addHomepageBrick_onSuccess,
			onFailure:Homepage.addHomepageBrick_onFailure
		});
	},
	addHomepageBrick_onSuccess: function(transport){
		if(!transport.responseJSON || !transport.responseJSON.created){
			return Homepage.addHomepageBrick_onFailure(transport);
		}
		Homepage.renderBrick(transport.responseJSON.created);
		Homepage.stopConfig();
		Homepage.startConfig();
		ui.closeModalBox();
	},
	addHomepageBrick_onFailure: function(transport){
		var msg=transport.responseText;
		if(transport.responseJSON && transport.responseJSON.error){
			msg=transport.responseJSON.error;
		} 
		alert("Server reported an error:\n\n"+msg+"\n\nThe page will reload when you click OK.");
		ui.forceReload();
	},
	
	init:function(){
		new Ajax.Request(apiUrl,{
			method:"get",
			onSuccess:Homepage.init_onSuccess,
			onFailure:Homepage.init_onFailure
		});
	},
	init_onSuccess:function(transport){
		AjaxUtils.checkResponse(transport);
		transport.responseJSON.rows.each(function(b){
 			b.headertemplates=eval(b.headertemplates);
  			b.rowtemplates=eval(b.rowtemplates);
			Homepage.renderBrick(b);
		});
		if(isDefaultHomepage){ Homepage.startConfig(); }
		ui.smallScreenInit();
	},
	init_onFailure:function(transport){
		AjaxUtils.checkResponse(transport);
	},

	renderBrick:function(b){
		var classes="homepagebrick r"+b.row+" c"+b.col+" w"+b.width+" h"+b.height;
		if(b.adminonly==true && !isAdmin){
			var box=grid.box({
				id:b.name,
				classes:classes,
				title:b.title,
				content:'<h3>Admin-only brick</h3><p>This brick is useless because you\'re not an administrator. You might as well remove it.</p><input type="button" id=""value="Remove brick" class="removebutton"/>',
			});
			box=box.up(".box");
			box.dataset.r=b.row;
			box.dataset.c=b.col;
			box.dataset.h=b.height;
			box.dataset.w=b.width;
			box.dataset.homepagebrickid=b.homepagebrickid;
			box.dataset.homepageuserbrickid=b.id;
			box.down(".removebutton").observe("click",Homepage.removeBrick);
			return;
		}
		if(b.rowtemplates){
			//For XSS prevention, all server responses are escaped. Brick templates are assumed safe, they should be 
			//reviewed manually to ensure that this is the case. Unescape them here:
			var unescapedTemplates=new Array();
			if('string'==typeof(b.rowtemplates)){
				b.rowtemplates=eval(b.rowtemplates);
			}
			b.rowtemplates.each(function(rt){
				if(typeof(rt)=="string"){
					var ta=document.createElement("textarea");
					ta.innerHTML=rt;
					rt=ta.textContent.trim();
	 			} else if(rt.length==2){
					rt=new Array(rt[0], rt[1]);
				}
	 			unescapedTemplates.push(rt);
			});
		}	
		if(b.headertemplates){
			b.headertemplates=eval(b.headertemplates);
		}	
		//Script supplied in a homepage brick template is assumed to have been checked manually for safety.
		//Have to eval it to use it. 
		var successHandler=null;
		if(b.scriptblock){
			var ta=document.createElement("textarea");
			ta.innerHTML=b.scriptblock;
			eval(ta.textContent);
			if(document[b.name+"_functions"]!=undefined && document[b.name+"_functions"].onSuccess!=undefined){
				successHandler=document[b.name+"_functions"].onSuccess;
			}
		}
		var box=grid.box({
			id:b.name,
			classes:classes,
			title:b.title,
			content:b.content.unescapeHTML(),
			url:b.apiurl.unescapeHTML().replace('{{userid}}',currentUser.id),
			headers:b.headertemplates,
			cellTemplates:unescapedTemplates,
			successHandler:successHandler
		});
		box=box.up(".box");
		box.dataset.r=b.row;
		box.dataset.c=b.col;
		box.dataset.h=b.height;
		box.dataset.w=b.width;
		box.dataset.homepagebrickid=b.homepagebrickid;
		if(isDefaultHomepage){
			box.dataset.homepagedefaultbrickid=b.id;
		} else {
			box.dataset.homepageuserbrickid=b.id;
		}
	}
	
}


$("configbutton").observe("click", Homepage.toggleConfig);
Homepage.init();
</script>

<?php include realpath(__DIR__).'/../_common/footer.php'; ?>